import type { InitialInputs } from "./InitialInputs";
import type { ObjectInputPaths } from "@octopusdeploy/step-inputs";
import type { FormContent } from "./FormContent";
import type { StepInputComponent } from "./InputComponents";
import type { ConfigurationExport } from "./ConfigurationExport";
import { NoteExpression } from "./Note";
export interface StepUI<StepInputs> {
    editInputsForm: EditStepInputsForm<StepInputs>;
    createInitialInputs: () => InitialInputs<StepInputs>;
    exportConfiguration?: ConfigurationExport<StepInputs>[];
    configuration?: StepUIConfiguration;
}
export declare type StepUIConfiguration = StepUIContainerConfiguration & {
    canUseExecutionTimeouts?: boolean;
    useConfigurationUISection?: boolean;
};
declare type StepUIContainerConfiguration = {
    canRunInExecutionContainer?: false;
} | {
    canRunInExecutionContainer: true;
    containerImageRecommendation?: NoteExpression[];
};
export declare const defaultStepUIConfiguration: StepUIConfiguration;
export declare type EditStepInputsForm<StepInputs> = (inputPaths: ObjectInputPaths<StepInputs>) => FormContent<StepInputComponent>[];
export {};
